#include <stdio.h>
#include <stdlib.h>
#include "emo.h"

int main(int argc, char **argv) {
  int size, dim, resolution, i, j;
  EMO_VPath vpath;
  double *data, z;

  if(argc != 3) {
    printf("Syntax: %s pareto_front_file int_resolution\n", argv[0]);
    exit(1);
  }

  size = dim = 0;
  data = EMO_File_read(NULL, &size, &dim, argv[1], 0);
  z = EMO_dmax(NULL, data, NULL, size * dim);

  resolution = atoi(argv[2]);
  EMO_VPath_alloc(&vpath, resolution, size, dim);
  EMO_VPath_run(&vpath, data, NULL, size, z);
  EMO_VPath_contribution(&vpath, data, NULL, size, z, NULL);

  EMO_VPath_write(&vpath, "matrix_fin.out");

  for(i = 0; i < vpath.y; i++) {
    for(j = 0; j < vpath.x; j++)
      printf("%d\t", vpath.M[i*vpath.x+j]);
    printf("\n");
  }

  for(i = 0; i < size; i++) {
    printf("c[%d] = %f, ", i, vpath.c[i]);
    EMO_vprint(stdout, data + i * dim, dim, "");
  }

  EMO_VPath_free(&vpath);

  free(data);

  return 0;
}

